"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var isBrowser = typeof document !== 'undefined';
var classCache = new Set();
var style;
if (isBrowser) {
    style = document.createElement('style');
    var head = document.querySelector('head');
    head === null || head === void 0 ? void 0 : head.appendChild(style);
}
exports.addClasses = function (classes) {
    var css = '';
    for (var x = 0; x < classes.length; x += 2) {
        var className = classes[x];
        if (classCache.has(className)) {
            continue;
        }
        classCache.add(className);
        var cssString = classes[x + 1];
        css += cssString + "\n";
    }
    if (isBrowser) {
        style.appendChild(document.createTextNode(css));
    }
};
exports.fixSpecificity = function () {
    var e_1, _a, e_2, _b, e_3, _c;
    var classnames = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        classnames[_i] = arguments[_i];
    }
    var a = new Map();
    try {
        for (var classnames_1 = tslib_1.__values(classnames), classnames_1_1 = classnames_1.next(); !classnames_1_1.done; classnames_1_1 = classnames_1.next()) {
            var name_1 = classnames_1_1.value;
            if (typeof name_1 === 'string') {
                try {
                    for (var _d = (e_2 = void 0, tslib_1.__values(name_1.split(' '))), _e = _d.next(); !_e.done; _e = _d.next()) {
                        var n = _e.value;
                        a.set(n.substr(0, n.indexOf(process.env.NODE_ENV === 'production' ? '_' : '__')), n);
                    }
                }
                catch (e_2_1) { e_2 = { error: e_2_1 }; }
                finally {
                    try {
                        if (_e && !_e.done && (_b = _d.return)) _b.call(_d);
                    }
                    finally { if (e_2) throw e_2.error; }
                }
            }
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (classnames_1_1 && !classnames_1_1.done && (_a = classnames_1.return)) _a.call(classnames_1);
        }
        finally { if (e_1) throw e_1.error; }
    }
    var classname = '';
    try {
        for (var _f = tslib_1.__values(a.values()), _g = _f.next(); !_g.done; _g = _f.next()) {
            var n = _g.value;
            classname += n + " ";
        }
    }
    catch (e_3_1) { e_3 = { error: e_3_1 }; }
    finally {
        try {
            if (_g && !_g.done && (_c = _f.return)) _c.call(_f);
        }
        finally { if (e_3) throw e_3.error; }
    }
    return classname;
};
var throwError = function () {
    throw new Error('CLASSY-UI: The plugin is not active. Either you are in a macro environment and you forgot to import from "classy-ui/macro", or the plugin is not added in your babel configuration');
};
exports.c = throwError;
exports.t = throwError;
exports.compose = throwError;
exports.tokens = throwError;
exports.themes = throwError;
exports.group = throwError;
//# sourceMappingURL=index.js.map